var api_url = 'http://epay.ncc.co.id/epay/api';
var key = '5e03e81b9fb8e6f0e425de942cdde2e2';
var company = 'luxury-qiu9.com';

window.LoginView = Backbone.View.extend({
    initialize:function () {
        
    },
    template: _.template($('#login').html()),
    events: {
        "click #btn-verify": "verify"
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    verify:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        
        if($('#username').val().length == 0 || $('#password').val().length == 0) {
            $('#password').val('');
            alert("Silakan mengisi Nomor Handphone dan Password");
        } else {
            $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

            var url = api_url + '/login/';
            var arr_post_data = {
                apikey: key,
                company: company,
                username: $('#username').val(),
                password: $('#password').val()
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    if(response.status === 'S') {
                        var arr_data = response.data;
                        window.localStorage['sess_id'] = arr_data.idsys_member;
                        window.localStorage['sess_token'] = arr_data.token;
                        window.localStorage['sess_username'] = arr_post_data.username;
                        window.localStorage['sess_password'] = arr_post_data.password;
                        window.location.href = '#menu';
                    } else {
                        $('#password').val('');
                        alert(response.message);
                    }
                }
            });
        }
    }
});

window.MenuView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#menu').html()),
    render:function (eventName) {
        $(this.el).html(this.template());
        return this;
    }
});

window.PembayaranView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#pembayaran').html()),
    events: {
        "click #btn-inquiry": "inquiry",
        "click #btn-payment": "payment",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    inquiry:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var product = $("#pembayaran_product").val();
        var product_code = '';
        if(product == 'pdam') {
            product_code = $("#product_code").val();
        } else {
            product_code = product;
        }
        
        var idpel = $("#idpel").val();
        var url = api_url + '/inquiry/';
        
        if(idpel.length == 0) {
            alert('Silakan isi Nomor Pelanggan');
            $.mobile.loading('hide');
        } else if(product_code.length == 0) {
            alert('Terdapat kesalahan. Silakan ulangi.');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                product_code: product_code,
                idpel: idpel
            };
            
            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    if(response.status === 'S') {
                        $("#div-payment").html(response.form_payment);
                    } else {
                        alert(response.message);
                    }
                }
            });
        }
    },
    payment:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var product = $("#pembayaran_product").val();
        var nomorhp = $("#nomorhp").val();
        var product_code = '';
        if(product == 'pdam') {
            product_code = $("#product_code").val();
        } else {
            product_code = product;
        }
        
        var url = api_url + '/payment/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"],
            product_code: product_code,
            nomorhp: nomorhp
        };
        $("#div-payment input.hiddenval").each(function() {
            arr_post_data[this.id] = $(this).val();
        });
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                alert(response.message);
                if(response.status === 'S') {
                    $("#idpel").val('');
                    $("#nomorhp").val('');
                    $("#div-payment").html('');
                }
            }
        });
    }
});

window.PembelianView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#pembelian').html()),
    events: {
        "click #btn-buy": "payment",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    payment:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };
        
        var url = '';
        var product = $("#pembelian_product").val();
        switch(product) {
            case "pulsa":
                url = api_url + '/pulsa/';
                arr_post_data['product_code'] = $("#product_id").val();
                arr_post_data['idpel'] = $("#idpel").val();
                break;
                
            case "pln":
                url = api_url + '/voucher_pln_prepaid/';
                arr_post_data['product_code'] = $("#product_id").val();
                arr_post_data['idpel'] = $("#idpel").val();
                arr_post_data['nomorhp'] = $("#nomorhp").val();
                break;
                
            case "game":
                url = api_url + '/voucher_game/';
                arr_post_data['product_code'] = $("#product_id").val();
                arr_post_data['idpel'] = $("#idpel").val();
                arr_post_data['nomorhp'] = $("#nomorhp").val();
                break;
        }
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                alert(response.message);
                $("#idpel").val('');
                if($('#nomorhp').length) {
                    $("#nomorhp").val('');
                }
                //$("#product_id").val('');
            }
        });
    }
});

window.PulsaView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#pulsa').html()),
    events: {
        "click #btn-inquiry-pulsa": "inquiry",
        "click #btn-payment-pulsa": "payment",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    inquiry:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var nomorhp = $("#nomorhp").val();
        var url = api_url + '/get_list_produk_pulsa_bakoel/';
        
        if(nomorhp.length == 0) {
            alert('Silakan isi Nomor HP Pelanggan');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                nomorhp: nomorhp
            };
            
            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    if(response.status === 'S') {
                        $select = $("#pulsa_product_code");
                        $.each(response.data, function(i, item) {
                            $select.append("<option value='" + item.product_id + "|" + item.product_price + "'>" + item.product_title + "</option>");
                        });
                        $("#idpel").val($("#nomorhp").val());
                        $("#nomorhp").attr('disabled', true);
                        $("#btn-inquiry-pulsa").hide();
                        $("#div-payment-pulsa").show();
                    } else {
                        alert(response.message);
                    }
                }
            });
        }
    },
    payment:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var product_code = $("#pulsa_product_code").val();
        var idpel = $("#idpel").val();
        var url = api_url + '/pulsa_bakoel/';
        
        if(product_code.length == 0) {
            alert('Silakan Pilih Nominal');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                token: window.localStorage["sess_token"],
                id: window.localStorage["sess_id"],
                product_code: product_code,
                idpel: idpel
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status === 'S') {
                        $("#idpel").val('');
                        $("#nomorhp").val('');
                        $("#nomorhp").prop('disabled', false);
                        $("#btn-inquiry-pulsa").show();
                        $("#div-payment-pulsa").hide();
                        $("#pulsa_product_code").find('option').remove().end().append('<option value="">Pilih Nominal</option>').val('');
                        $("#pulsa_product_code").selectmenu('refresh', true);
                    }
                }
            });
        }
    }
});

window.TopupView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#topup').html()),
    events: {
        "click #btn-topup": "send_topup_request",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    send_topup_request:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/topup/';
        var nominal_topup = parseInt($("#nominal_topup").val());
        var keterangan_topup = $("#keterangan_topup").val();
        var bank_tujuan_topup = $("#bank_tujuan_topup").val();
        
        if(nominal_topup < 50000) {
            alert('Minimal Top Up Deposit adalah Rp. 50.000,-');
            $.mobile.loading('hide');
        } else if(bank_tujuan_topup == '') {
            alert('Silakan pilih Bank Tujuan transfer');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                token: window.localStorage["sess_token"],
                id: window.localStorage["sess_id"],
                nominal: nominal_topup,
                keterangan: keterangan_topup,
                bank_tujuan: bank_tujuan_topup
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status == 'S') {
                        $("#nominal_topup").val('');
                        $("#keterangan_topup").val('');
                        //$("#bank_tujuan_topup").val('');
                    }
                }
            });
        }
    }
});

window.TransferView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#transfer').html()),
    events: {
        "click #btn-transfer": "send_transfer_request",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    send_transfer_request:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/transfer/';
        var penerima_transfer = $("#penerima_transfer").val();
        var nominal_transfer = parseInt($("#nominal_transfer").val());
        var keterangan_transfer = $("#keterangan_transfer").val();
        
        if(nominal_transfer < 50000 || nominal_transfer > 5000000) {
            alert('Minimal Transfer Deposit adalah Rp. 50.000,- dan Maksimal Transfer Deposit adalah Rp. 5.000.000,-');
            $.mobile.loading('hide');
        } else if(penerima_transfer.length == 0) {
            alert('Silakan isi E-Mail / No HP Penerima');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                token: window.localStorage["sess_token"],
                id: window.localStorage["sess_id"],
                penerima: penerima_transfer,
                nominal: nominal_transfer,
                keterangan: keterangan_transfer
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status == 'S') {
                        $("#penerima_transfer").val('');
                        $("#nominal_transfer").val('');
                        $("#keterangan_transfer").val('');
                        if(typeof(response.data) != "undefined" && response.data !== null) {
                            $("#informasi_transfer_saldo").html('Saldo deposit anda saat ini adalah <b>Rp. ' + response.data + ',-<br />')
                        }
                    }
                }
            });
        }
    }
});

window.RegistrasiView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#registrasi').html()),
    events: {
        "click #btn-registrasi": "send_registrasi",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    send_registrasi:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/registrasi/';
        var nama_registrasi = $("#nama_registrasi").val();
        var nomorhp_registrasi = $("#nomorhp_registrasi").val();
        var email_registrasi = $("#email_registrasi").val();
        var serial_registrasi = $("#serial_registrasi").val();
        var email_filter = /^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
        
        if(nama_registrasi.length == 0 || nomorhp_registrasi.length == 0) {
            alert('Silakan isi Nama Lengkap dan Nomor Handphone');
            $.mobile.loading('hide');
        } else if(email_registrasi.length > 0 && !email_filter.test(email_registrasi)) {
            alert('Silakan isi Alamat E-Mail dengan benar');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                token: window.localStorage["sess_token"],
                id: window.localStorage["sess_id"],
                name: nama_registrasi,
                phone: nomorhp_registrasi,
                email: email_registrasi,
                serial: serial_registrasi
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status == 'S') {
                        $("#nama_registrasi").val('');
                        $("#nomorhp_registrasi").val('');
                        $("#email_registrasi").val('');
                        $("#serial_registrasi").val('');
                    }
                }
            });
        }
    }
});

window.KeretaAPIView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#keretaapi').html()),
    events: {
        "click #btn-kai-one": "payment_kai_one",
        "click .btn-kai-two": "payment_kai_two",
        "click #btn-kai-three": "payment_kai_three",
        "click #btn-kai-four": "payment_kai_four",
        "click .btn-kai-five": "payment_kai_five",
        "click .btn-kai-six": "payment_kai_six"
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    payment_kai_one:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var tanggal_keberangkatan = $("#tanggal_keberangkatan").val();
        var asal_keberangkatan = $("#asal_keberangkatan").val();
        var tujuan_keberangkatan = $("#tujuan_keberangkatan").val();
        var jumlah_dewasa = $("#penumpang_dewasa").val();
        var jumlah_bayi = $("#penumpang_bayi").val();
            
        var url = api_url + '/kaiSearch_get/';
        
        if(tanggal_keberangkatan === "" || asal_keberangkatan === "" || tujuan_keberangkatan === "" || jumlah_dewasa === "" || jumlah_dewasa === "0") {
            if(jumlah_dewasa !== ""){
                if(jumlah_dewasa !== "0"){
                    alert('Silakan Lengkapi Data');
                }else{
                    alert('Minimal Penumpang Dewasa 1 Orang');
                }
            }else{
                alert('Silahkan isi penumpang dewasa');
            }
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                date : tanggal_keberangkatan,
                source : asal_keberangkatan,
                destination : tujuan_keberangkatan,
                jumlah_dewasa : jumlah_dewasa,
                jumlah_bayi : jumlah_bayi
            };
            
            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    if(response.status === 'S') {
                        if(response.errCode === '0'){
                            $(".list-tiket-kai").empty();
                            $(".list-tiket-kai").append(response.judul);
                            $.each(response.data, function(i, item) {
                                $(".list-tiket-kai").append(item);
                            });
                            $("#div-keretaapi-two").show(); 
                        }else if(response.errCode === '510101'){
                            $("#div-keretaapi-two").hide();
                            alert('Rute Tidak Tersedia');
                        }else{
                            $("#div-keretaapi-two").hide();
                            alert('Unknown Error');                          
                        }
                    } else {
                        alert(response.message);
                    }
                }
            });
        }        
    },
    payment_kai_two:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

        var data_kereta = event.target.value;
        var url = api_url + '/kaiFormInputPenumpang_get/';
        var arr_post_data = {
            apikey: key,
            data_kereta : data_kereta
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    var dataItinerary = response.data.itinerary;
                    var arrayItinerary = dataItinerary.split("|");

                    var jumlah_dewasa = arrayItinerary[12];
                    var jumlah_bayi = arrayItinerary[13];

                    document.getElementById('itinerary').value = response.data.itinerary;
                    document.getElementById('nomorKursi').value = response.data.nomorKursi;
                    document.getElementById('kelasWagon').value = response.data.kelasWagon;
                    document.getElementById('nomorWagon').value = response.data.nomorWagon;

                    for (i = 0; i < jumlah_dewasa; i++) {
                        if(i > 0){
                            var num     = $('.penumpangDewasa').length;
                            var newNum  = new Number(num + 1);
                            var newSection = $('#penumpangDewasa' + num).clone().attr('id', 'penumpangDewasa' + newNum);

                            $('.penumpangDewasa').last().append(newSection);
                        }
                        var j = new Number(i + 1);
                        document.getElementsByClassName("penumpangDewasa_title")[i].innerHTML = 'Penumpang Dewasa '+j;
                    }

                    if(jumlah_bayi > 0){
                        for (i = 0; i < jumlah_bayi; i++) {
                            if(i > 0){
                                var num     = $('.penumpangBayi').length;
                                var newNum  = new Number(num + 1);
                                var newSection = $('#penumpangBayi' + num).clone().attr('id', 'penumpangBayi' + newNum);

                                $('.penumpangBayi').last().append(newSection);
                            }
                            var j = new Number(i + 1);
                            document.getElementsByClassName("penumpangBayi_title")[i].innerHTML = 'Penumpang Bayi '+j;
                        }
                    }else{
                        $("#penumpangBayi1").empty();
                    }

                    $("#list-itinerary").html(response.data.listItinerary);
                    $("#div-keretaapi-one").hide();
                    $("#div-keretaapi-two").hide();
                    $("#div-keretaapi-three").show();
                    console.log(2 + 3);
                } else {
                    alert(response.message);
                }
            }
        });
    },
    payment_kai_three:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var jumlah_dewasa = $("#penumpang_dewasa").val();
        var penumpang_bayi = $("#penumpang_bayi").val();
        var nama_penumpang = "";
        var id_penumpang = "";
        var tgllahir_penumpang = "";
        var nohp_penumpang = "";
        
        var itinerary = $("#itinerary").val();
        var nomorKursi = $("#nomorKursi").val();
        var kelasWagon = $("#kelasWagon").val();
        var nomorWagon = $("#nomorWagon").val();
        
        for(i=0; i<jumlah_dewasa; i++){
            if(i == 0){
                nama_penumpang = document.getElementsByClassName("nameDewasa")[i].value;
                id_penumpang = document.getElementsByClassName("idDewasa")[i].value;
                tgllahir_penumpang = document.getElementsByClassName("tgllahirDewasa")[i].value;
                nohp_penumpang = document.getElementsByClassName("nohpDewasa")[i].value;
            }else{
                nama_penumpang = nama_penumpang  +'|'+ document.getElementsByClassName("nameDewasa")[i].value;
                id_penumpang = id_penumpang  +'|'+ document.getElementsByClassName("idDewasa")[i].value;
                tgllahir_penumpang = tgllahir_penumpang  +'|'+ document.getElementsByClassName("tgllahirDewasa")[i].value;
                nohp_penumpang = nohp_penumpang  +'|'+ document.getElementsByClassName("nohpDewasa")[i].value;
            }
        }
        
        for(i=0; i<penumpang_bayi; i++){
            nama_penumpang = nama_penumpang  +'|'+ document.getElementsByClassName("nameBayi")[i].value;
            tgllahir_penumpang = tgllahir_penumpang  +'|'+ document.getElementsByClassName("tgllahirBayi")[i].value;
        }
            
        var url = api_url + '/kaiBooking_get/';
        
        var arr_post_data = {
            apikey: key,
            member_id: window.localStorage["sess_id"],
            nama_penumpang : nama_penumpang,
            id_penumpang : id_penumpang,
            tgllahir_penumpang : tgllahir_penumpang,
            nohp_penumpang : nohp_penumpang,
            itinerary : itinerary,
            nomorKursi : nomorKursi,
            kelasWagon : kelasWagon,
            nomorWagon : nomorWagon
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    if(response.data.statusBooking == 'sukses'){
                        document.getElementById('bookingCode').value = response.data.databooking.bookingCode;
                        document.getElementById('totalPrice').value = response.data.databooking.totalPrice;
                        document.getElementById('nomorHandphoneCustomer').value = response.data.databooking.contact[0][1];
                        $("#list-booking-tiket-kai").html(response.data.listBooking);
                        $("#div-keretaapi-three").hide();
                        $("#div-keretaapi-four").show();
                    }else{
                        alert(response.data.databooking.msg);
                    }
                } else {
                    alert(response.message);
                }
            }
        });
    },
    payment_kai_four:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
       
        var bookingCode = $("#bookingCode").val();
        var totalPrice = $("#totalPrice").val();
        var nomorHandphoneCustomer = $("#nomorHandphoneCustomer").val();
            
        var url = api_url + '/kaiIssued_get/';
        
        var arr_post_data = {
            apikey: key,
            member_id: window.localStorage["sess_id"],
            bookingCode : bookingCode,
            totalPrice : totalPrice,
            nomorHandphoneCustomer : nomorHandphoneCustomer
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    alert(response.message);
                    
                    $("#list-booking-tiket-kai").clone().appendTo("#final-issued-tiket-kai");
                    $("#div-keretaapi-four").hide();
                    $("#div-keretaapi-five").show();
                } else {
                    alert(response.message);
                }
            }
        });        
    },
    payment_kai_five:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'hide', { text: "Loading...please wait", textonly: false });

        var valueDetail = event.target.value;

        var url = api_url + '/kaiDetailBooking_get/';
        
        var arr_post_data = {
            apikey: key,
            valueDetail : valueDetail
        };
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    if(response.data.statusBooking == 'sukses'){
                        document.getElementById('bookingCode').value = response.data.databooking.bookingCode;
                        document.getElementById('totalPrice').value = response.data.databooking.totalPrice;
                        document.getElementById('nomorHandphoneCustomer').value = response.data.databooking.contact[0][1];
                        $("#list-booking-tiket-kai").html(response.data.listBooking);
                        $("#div-keretaapi-six").hide();
                        $("#div-keretaapi-four").show();
                    }else{
                        alert(response.data.databooking.msg);
                    }
                } else {
                    alert(response.message);
                }
            }
        });     
    },
    payment_kai_six:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'hide', { text: "Loading...please wait", textonly: false });

        var valueDetail = event.target.value;

        var url = api_url + '/kaiDetailBooking_get/';
        
        var arr_post_data = {
            apikey: key,
            valueDetail : valueDetail
        };
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    if(response.data.statusBooking == 'sukses'){
                        document.getElementById('bookingCode').value = response.data.databooking.bookingCode;
                        document.getElementById('totalPrice').value = response.data.databooking.totalPrice;
                        document.getElementById('nomorHandphoneCustomer').value = response.data.databooking.contact[0][1];
                        $("#final-issued-tiket-kai").html(response.data.listBooking);
                        $("#div-keretaapi-seven").hide();
                        $("#div-keretaapi-five").show();
                    }else{
                        alert(response.data.databooking.msg);
                    }
                } else {
                    alert(response.message);
                }
            }
        });     
    }
});

window.SaldoView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#saldo').html()),
    render:function () {
        $(this.el).html(this.template());
        return this;
    }
});

window.ReportView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#report').html()),
    render:function () {
        $(this.el).html(this.template());
        return this;
    }
});

window.Registrasi_newView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#registrasi_new').html()),
    events: {
        "click #btn-registrasi-new": "send_registrasi",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    send_registrasi:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/registrasi_new/';
        var nama_registrasi = $("#nama_registrasi").val();
        var nomorhp_registrasi = $("#nomorhp_registrasi").val();
        var email_registrasi = $("#email_registrasi").val();
        var email_filter = /^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
        
        if(nama_registrasi.length == 0 || nomorhp_registrasi.length == 0) {
            alert('Silakan isi Nama Lengkap dan Nomor Handphone');
            $.mobile.loading('hide');
        } else if(email_registrasi.length > 0 && !email_filter.test(email_registrasi)) {
            alert('Silakan isi Alamat E-Mail dengan benar');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                name: nama_registrasi,
                phone: nomorhp_registrasi,
                email: email_registrasi
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status == 'S') {
                        $("#nama_registrasi").val('');
                        $("#nomorhp_registrasi").val('');
                        $("#email_registrasi").val('');
                    }
                }
            });
        }
    }
});

window.VerifikasiView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#verifikasi').html()),
    events: {
        "click #btn-verifikasi": "send_verifikasi",
    },
    render:function () {
        $(this.el).html(this.template());
        return this;
    },
    send_verifikasi:function (event) {
        event.preventDefault(); // Don't let this button submit the form
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/verifikasi/';
        var kode_serial = $("#kode_serial").val();

        if(kode_serial.length == 0) {
            alert('Silakan isi kode serial');
            $.mobile.loading('hide');
        } else {
            var arr_post_data = {
                apikey: key,
                token: window.localStorage["sess_token"],
                id: window.localStorage["sess_id"],
                serial: kode_serial
            };

            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    alert(response.message);
                    if(response.status == 'S') {
                        $("#nomor_serial").append(response.serial);
                        $("#type_membership").append(response.typess);
                        $("#verified-no").hide();
                        $("#verified-yes").show();
                    }
                }
            });
        }
    }
});

window.VirtualofficeView = Backbone.View.extend({
    initialize:function () {
        
    },
    template:_.template($('#menu').html()),
    render:function () {
        $(this.el).html(this.template());
        return this;
    }
});

var AppRouter = Backbone.Router.extend({
    routes:{
        "":"login",
        "menu":"menu",
        "login":"login",
        "logout":"logout",
        "pembayaran/:product":"pembayaran",
        "pembelian/:product":"pembelian",
        "pulsa":"pulsa",
        "topup":"topup",
        "transfer":"transfer",
        "registrasi":"registrasi",
        "keretaapi/:sub_menu":"keretaapi",
        "saldo":"saldo",
        "report":"report",
        "registrasi_new":"registrasi_new",
        "verifikasi":"verifikasi",
        "virtualoffice":"virtualoffice",
    },
    initialize:function () {
        // Handle back button throughout the application
        $('.back').live('click', function(event) {
            window.history.back();
            return false;
        });
        this.firstPage = true;
    },
    authorization:function() {
        if (window.localStorage["sess_id"] == undefined || window.localStorage["sess_id"] == 0) {
            window.location.href = '#login';
        }
    },
    login:function () {
        var page = new LoginView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-login');
        page.render();
        $('body').append($(page.el));
        
        if (window.localStorage["sess_username"] != undefined && window.localStorage["sess_password"] != undefined) {
            $("#username").val(window.localStorage["sess_username"]);
            $("#password").val(window.localStorage["sess_password"]);
        }
        
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    logout: function () {
        var url = api_url + '/logout/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data
        });
        
        localStorage.sess_id = 0;
        localStorage.sess_token = 0;
        localStorage.sess_username = '';
        localStorage.sess_password = '';
        localStorage.removeItem("sess_id");
        localStorage.removeItem("sess_token");
        localStorage.removeItem("sess_username");
        localStorage.removeItem("sess_password");
        window.location.href = '#login';
    },
    menu:function () {
        this.authorization();
        var page = new MenuView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-menu');
        page.render();
        $('body').append($(page.el));
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    pembayaran:function (product) {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        var title = '';
        switch(product) {
            case "plnpost":
                title = 'Pembayaran Tagihan PLN';
                break;

            case "plnpre":
                title = 'Pembelian Voucher PLN';
                break;

            case "pstn":
                title = 'Pembayaran Tagihan TELKOM';
                break;

            case "speedy":
                title = 'Pembayaran Tagihan TELKOM Speedy';
                break;

            case "flexi":
                title = 'Pembayaran Tagihan TELKOM Flexi';
                break;

            case "halo":
                title = 'Pembayaran Tagihan HALO';
                break;

            case "matrix":
                title = 'Pembayaran Tagihan Matrix';
                break;

            case "starone":
                title = 'Pembayaran Tagihan StarOne';
                break;

            case "maf":
                title = 'Pembayaran Tagihan Multifinance MAF';
                break;

            case "wom":
                title = 'Pembayaran Tagihan Multifinance WOM';
                break;

            case "baf":
                title = 'Pembayaran Tagihan Multifinance BAF';
                break;

            case "mcf":
                title = 'Pembayaran Tagihan Multifinance MCF';
                break;

            case "indovision":
                title = 'Pembayaran Tagihan Indovision';
                break;

            case "yestv":
                title = 'Pembayaran Tagihan YesTV';
                break;

            case "pdam":
                title = 'Pembayaran Tagihan PDAM';
                break;

            case "pgn":
                title = 'Pembayaran Tagihan Gas (PGN)';
                break;

            case "pbbdki":
                title = 'Pembayaran Tagihan PBB';
                break;
        }
        
        $("#pembayaran_options").html('');
        if(product === "pdam") {
            $select = $('<select id="product_code" data-native-menu="true" data-inline="false"></select>');
            $select.append('<option value="">Pilih Produk</option>');
            var url = api_url + '/get_list_produk_pembayaran/';
            var arr_post_data = {
                apikey: key,
                product_code: product,
            };
            $.ajax({
                url: url,
                dataType: "jsonp",
                jsonp: "callback",
                data: arr_post_data,
                success: function (response) {
                    $.mobile.loading('hide');
                    if(response.status === 'S') {
                        $.each(response.data, function(i, item) {
                            $select.append("<option value='" + item.product_code + "'>" + item.product_title + "</option>");
                        });
                    } else {
                        alert(response.message);
                    }
                }
            });
        }
        
        var page = new PembayaranView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-pembayaran');
        page.render();
        $('body').append($(page.el));
        $("#pembayaran_title").html(title);
        $("#pembayaran_product").val(product);
        if(product === "pdam") {
            $("#pembayaran_options").append($select);
        }

        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    pembelian:function (product) {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var product_code = '';
        var title = '';
        $params = $('<div id="pembelian_params"></div>');
        switch(product) {
            case "plnpre":
                product_code = 'pln';
                title = 'Pembelian Voucher PLN';
                $params.append('<input id="idpel" placeholder="ID Pelanggan..." value="" data-clear-btn="true" type="text" />');
                $params.append('<input id="nomorhp" placeholder="Nomor HP Pelanggan..." value="" data-clear-btn="true" type="number" pattern="[0-9]*" />');
                break;

            case "pulsa":
                product_code = 'pulsa';
                title = 'Pembelian Pulsa';
                $params.append('<input id="idpel" placeholder="Nomor Handphone..." value="" data-clear-btn="true" type="number" pattern="[0-9]*" />');
                break;

            case "game":
                product_code = 'game';
                title = 'Pembelian Voucher Game';
                $params.append('<input id="idpel" placeholder="ID Pelanggan..." value="" data-clear-btn="true" type="text" />');
                $params.append('<input id="nomorhp" placeholder="Nomor HP Pelanggan..." value="" data-clear-btn="true" type="number" pattern="[0-9]*" />');
                break;
        }
        
        $select = $('<select id="product_id" data-native-menu="true" data-inline="false"></select>');
        $select.append('<option value="">Pilih Produk</option>');
        var url = api_url + '/get_list_produk_pembelian/';
        var arr_post_data = {
            apikey: key,
            product_code: product_code,
        };
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    $.each(response.data, function(i, item) {
                        $select.append("<option value='" + item.product_code + "'>" + item.product_title + " (Rp. " + item.product_price + ")</option>");
                    });
                } else {
                    alert(response.message);
                }
            }
        });

        var page = new PembelianView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-pembelian');
        page.render();
        $('body').append($(page.el));
        $("#pembelian_title").html(title);
        $("#pembelian_product").val(product_code);
        $("#pembelian_options").append($select).after($params);
		
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    pulsa:function () {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var page = new PulsaView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-pulsa');
        page.render();
        $('body').append($(page.el));

        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    topup:function () {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        $select = $('<select id="bank_tujuan_topup" data-native-menu="true" data-inline="false"></select>');
        $select.append('<option value="">Pilih Bank Tujuan</option>');
        var url = api_url + '/get_list_bank_tujuan_topup/';
        var arr_post_data = {
            apikey: key,
        };
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    $.each(response.data, function(kode_bank, nama_bank) {
                        $select.append("<option value='" + kode_bank + "'>" + nama_bank + "</option>");
                    });
                } else {
                    alert(response.message);
                }
            }
        });

        var page = new TopupView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-topup');
        page.render();
        $('body').append($(page.el));
        $("#bank_tujuan_topup_options").append($select);
		
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    transfer:function () {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/get_ewallet_balance/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };
        
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    $("#informasi_transfer_saldo").html('Saldo deposit anda saat ini adalah <b>Rp. ' + response.data + ',-<br />');
                } else {
                    alert(response.message);
                }
            }
        });

        var page = new TransferView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-transfer');
        page.render();
        $('body').append($(page.el));
		
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    registrasi:function () {
        this.authorization();
        var page = new RegistrasiView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-registrasi');
        page.render();
        $('body').append($(page.el));
		
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    keretaapi:function (sub_menu) {
        switch(sub_menu) {
            case "search":
                this.authorization();
                $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
                
                $select_asal = $('<select id="asal_keberangkatan" data-native-menu="true" data-inline="false"></select>');
                $select_tujuan = $('<select id="tujuan_keberangkatan" data-native-menu="true" data-inline="false"></select>');
                $select_penumpang_dewasa = $('<select id="penumpang_dewasa" data-native-menu="true" data-inline="false"></select>');
                $select_penumpang_bayi = $('<select id="penumpang_bayi" data-native-menu="true" data-inline="false"></select>');
                $select_asal.append('<option value="">Pilih Asal Keberangkatan</option>');
                $select_tujuan.append('<option value="">Pilih Tujuan Keberangkatan</option>');
                $select_penumpang_dewasa.append('<option value="">Jumlah Penumpang Dewasa</option>');
                $select_penumpang_bayi.append('<option value="">Jumlah Penumpang Bayi</option>');
                
                var url = api_url + '/kaiGetStationList_get/';
                var arr_post_data = {
                    apikey: key,
                };

                $.ajax({
                    url: url,
                    dataType: "jsonp",
                    jsonp: "callback",
                    data: arr_post_data,
                    success: function (response) {
                        $.mobile.loading('hide');
                        if(response.status === 'S') {
                            $.each(response.data, function(i, item) {
                                $select_asal.append("<option value='"+item.code+"|"+item.name+"|"+item.group+"'>" + item.group + ", "+item.name+" ("+item.code+")</option>");
                                $select_tujuan.append("<option value='"+item.code+"|"+item.name+"|"+item.group+"'>" + item.group + ", "+item.name+" ("+item.code+")</option>");
                            });
                            for(i=1; i<=4; i++){
                                $select_penumpang_dewasa.append("<option value='"+i+"'>"+i+" Orang</option>"); 
                                $select_penumpang_bayi.append("<option value='"+i+"'>"+i+" Orang</option>"); 
                            }
                        } else {
                            alert(response.message);
                        }
                    }
                });

                var page = new KeretaAPIView();
                $(page.el).attr('data-role', 'page');
                $(page.el).attr('id', 'page-keretaapi');
                page.render();
                $('body').append($(page.el));
                $("#asal_keberangkatan_options").append($select_asal);
                $("#tujuan_keberangkatan_options").append($select_tujuan);
                $("#penumpang_dewasa_options").append($select_penumpang_dewasa);
                $("#penumpang_bayi_options").append($select_penumpang_bayi);
                
                var transition = $.mobile.defaultPageTransition;
                // We don't want to slide the first page
                if (this.firstPage) {
                    transition = 'none';
                    this.firstPage = false;
                }
                $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
                
                $("#div-keretaapi-one").show();             
                break;
                
            case "listbooking":
                this.authorization();
                $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

                var url = api_url + '/kaiListBooking_get/';
                
                var arr_post_data = {
                    apikey: key,
                    id: window.localStorage["sess_id"]
                };

                $.ajax({
                    url: url,
                    dataType: "jsonp",
                    jsonp: "callback",
                    data: arr_post_data,
                    success: function (response) {
                        $.mobile.loading('hide');
                        if(response.status === 'S') {
                            $( ".list-booking-kai" ).append(response.judul);
                            $.each(response.data, function(i, item) {
                                $( ".list-booking-kai" ).append(item);
                            });
                        } else {
                            alert(response.message);
                        }
                    }
                });
                
                var page = new KeretaAPIView();
                $(page.el).attr('data-role', 'page');
                $(page.el).attr('id', 'page-keretaapi');
                page.render();
                $('body').append($(page.el));
                var transition = $.mobile.defaultPageTransition;
                // We don't want to slide the first page
                if (this.firstPage) {
                    transition = 'none';
                    this.firstPage = false;
                }
                $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
                
                $("#div-keretaapi-six").show();
                break;

            case "listissued":
                this.authorization();
                $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

                var url = api_url + '/kaiListIssued_get/';
                
                var arr_post_data = {
                    apikey: key,
                    id: window.localStorage["sess_id"]
                };

                $.ajax({
                    url: url,
                    dataType: "jsonp",
                    jsonp: "callback",
                    data: arr_post_data,
                    success: function (response) {
                        $.mobile.loading('hide');
                        if(response.status === 'S') {
                            $( ".list-issued-kai" ).append(response.judul);
                            $.each(response.data, function(i, item) {
                                $( ".list-issued-kai" ).append(item);
                            });
                        } else {
                            alert(response.message);
                        }
                    }
                });
                
                var page = new KeretaAPIView();
                $(page.el).attr('data-role', 'page');
                $(page.el).attr('id', 'page-keretaapi');
                page.render();
                $('body').append($(page.el));
                var transition = $.mobile.defaultPageTransition;
                // We don't want to slide the first page
                if (this.firstPage) {
                    transition = 'none';
                    this.firstPage = false;
                }
                $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
                
                $("#div-keretaapi-seven").show();
                break;
        }
    },
    saldo:function() {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });
        
        var url = api_url + '/get_ewallet_balance/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };
        
        $content = $('<div style="font-size:13pt; padding-top:20px;" id="saldo_content"></div>');
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    $content.append('Saldo deposit anda saat ini adalah <div style="font-size:16pt; padding-top:5px;"><b>Rp. ' + response.data + ',-</b></div>');
                } else {
                    alert(response.message);
                }
            }
        });
        
        var page = new SaldoView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-saldo');
        page.render();
        $('body').append($(page.el));
        $("#saldo_title").after($content);
        
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    report:function() {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

        var url = api_url + '/get_report_transaksi/';
        var arr_post_data = {
            apikey: key,
            id: window.localStorage["sess_id"]
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    $( ".list_report_transaksi" ).append(response.judul);
                    $.each(response.data, function(i, item) {
                        $( ".list_report_transaksi" ).append(item);
                    });
                } else {
                    alert(response.message);
                }
            }
        });
        
        var page = new ReportView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-report');
        page.render();
        $('body').append($(page.el));
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    registrasi_new:function () {
        var page = new Registrasi_newView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-registrasi-new');
        page.render();
        $('body').append($(page.el));
        
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    verifikasi:function () {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

        var url = api_url + '/verifikasi/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.verified === 'yes') {
                    $("#nomor_serial").append(response.serial);
                    $("#type_membership").append(response.type);
                    $("#verified-no").hide();
                    $("#verified-yes").show();    
                } else {
                    $("#verified-yes").hide();
                    $("#verified-no").show();
                }
            }
        });

        var page = new VerifikasiView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-verifikasi');
        page.render();
        $('body').append($(page.el));
        
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    },
    virtualoffice:function() {
        this.authorization();
        $.mobile.loading( 'show', { text: "Loading...please wait", textonly: false });

        var url = api_url + '/virtual_office/';
        var arr_post_data = {
            apikey: key,
            token: window.localStorage["sess_token"],
            id: window.localStorage["sess_id"]
        };

        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "callback",
            data: arr_post_data,
            success: function (response) {
                $.mobile.loading('hide');
                if(response.status === 'S') {
                    window.location = response.link;
                } else {
                    alert(response.message);
                }
            }
        });
        
        var page = new VirtualofficeView();
        $(page.el).attr('data-role', 'page');
        $(page.el).attr('id', 'page-virtualoffice');
        page.render();
        $('body').append($(page.el));
        var transition = $.mobile.defaultPageTransition;
        // We don't want to slide the first page
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    }

});

$(document).ready(function () {
    app = new AppRouter();
    Backbone.history.start();
});

//FUNCTION NUMBER FORMAT
Number.prototype.format = function(n, x, s, c) {
    var re = '\\d(?=(\\d{' + (x || 3) + '})+' + (n > 0 ? '\\D' : '$') + ')',
        num = this.toFixed(Math.max(0, ~~n));
    
    return (c ? num.replace('.', c) : num).replace(new RegExp(re, 'g'), '$&' + (s || ','));
};